__gnu_debug::_Safe_iterator< _Iterator, _Sequence > Class Template Reference

## Public Types

typedef _Traits::difference_type | difference_type
typedef _Traits::iterator_category | iterator_category
typedef _Iterator | iterator_type
typedef _Traits::pointer | pointer
typedef _Traits::reference | reference
typedef _Traits::value_type | value_type

## Public Member Functions

| _Safe_iterator () noexcept
| _Safe_iterator (_Safe_iterator &&__x) noexcept
| _Safe_iterator (const _Iterator &__i, const _Safe_sequence_base *__seq) noexcept
| _Safe_iterator (const _Safe_iterator &__x) noexcept
template<typename _MutableIterator >
| _Safe_iterator (const _Safe_iterator< _MutableIterator, typename __gnu_cxx::__enable_if<(std::__are_same< _MutableIterator, typename _Sequence::iterator::iterator_type >::__value), _Sequence >::__type > &__x) noexcept
void | _M_attach (_Safe_sequence_base *__seq)
void | _M_attach_single (_Safe_sequence_base *__seq)
bool | _M_before_dereferenceable () const
bool | _M_can_advance (const difference_type &__n) const
bool | _M_decrementable () const
bool | _M_dereferenceable () const
__gnu_cxx::__conditional_type< std::__are_same< _Const_iterator, _Safe_iterator >::__value, const _Sequence *, _Sequence * >::__type | _M_get_sequence () const
bool | _M_incrementable () const
bool | _M_is_before_begin () const
bool | _M_is_begin () const
bool | _M_is_beginnest () const
bool | _M_is_end () const
bool | _M_valid_range (const _Safe_iterator &__rhs, std::pair< difference_type, _Distance_precision > &__dist, bool __check_dereferenceable=true) const
const _Iterator & | base () const noexcept
_Iterator & | base () noexcept
| operator _Iterator () const noexcept
reference | operator* () const noexcept
_Safe_iterator | operator+ (const difference_type &__n) const noexcept
_Safe_iterator & | operator++ () noexcept
_Safe_iterator | operator++ (int) noexcept
_Safe_iterator & | operator+= (const difference_type &__n) noexcept
_Safe_iterator | operator- (const difference_type &__n) const noexcept
_Safe_iterator & | operator-- () noexcept
_Safe_iterator | operator-- (int) noexcept
_Safe_iterator & | operator-= (const difference_type &__n) noexcept
pointer | operator-> () const noexcept
_Safe_iterator & | operator= (_Safe_iterator &&__x) noexcept
_Safe_iterator & | operator= (const _Safe_iterator &__x) noexcept
reference | operator[] (const difference_type &__n) const noexcept

## Detailed Description

### template<typename _Iterator, typename _Sequence>
class __gnu_debug::_Safe_iterator< _Iterator, _Sequence >

Safe iterator wrapper.

The class template _Safe_iterator is a wrapper around an iterator that tracks the iterator's movement among sequences and checks that operations performed on the "safe" iterator are legal. In additional to the basic iterator operations (which are validated, and then passed to the underlying iterator), _Safe_iterator has member functions for iterator invalidation, attaching/detaching the iterator from sequences, and querying the iterator's state.

Note that _Iterator must be the first base class so that it gets initialized before the iterator is being attached to the container's list of iterators and it is being detached before _Iterator get destroyed. Otherwise it would result in a data race.

Definition at line 56 of file formatter.h.

## Constructor & Destructor Documentation

## _Safe_iterator() [1/5]

template<typename _Iterator , typename _Sequence >

__gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_Safe_iterator | ( |  | ) |

inline noexcept

Postcondition
  the iterator is singular and unattached

Definition at line 119 of file safe_iterator.h.

## _Safe_iterator() [2/5]

template<typename _Iterator , typename _Sequence >

__gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_Safe_iterator | ( | const _Iterator & | __i,
|  | const _Safe_sequence_base * | __seq
| ) |  |

inline noexcept

Safe iterator construction from an unsafe iterator and its sequence.

Precondition
  `seq` is not NULL

Postcondition
  this is not singular

Definition at line 128 of file safe_iterator.h.

## _Safe_iterator() [3/5]

template<typename _Iterator , typename _Sequence >

__gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_Safe_iterator | ( | const _Safe_iterator< _Iterator, _Sequence > & | __x | ) |

inline noexcept

Copy construction.

Definition at line 140 of file safe_iterator.h.

## _Safe_iterator() [4/5]

template<typename _Iterator , typename _Sequence >

__gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_Safe_iterator | ( | _Safe_iterator< _Iterator, _Sequence > && | __x | ) |

inline noexcept

Move construction.

Postcondition
  __x is singular and unattached

Definition at line 158 of file safe_iterator.h.

## _Safe_iterator() [5/5]

template<typename _Iterator , typename _Sequence >
template<typename _MutableIterator >

__gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_Safe_iterator | ( | const _Safe_iterator< _MutableIterator, typename __gnu_cxx::__enable_if<(std::__are_same< _MutableIterator, typename _Sequence::iterator::iterator_type >::__value), _Sequence >::__type | ,
|  | & | __x
| ) |  |

inline noexcept

Converting constructor from a mutable iterator to a constant iterator.

Definition at line 178 of file safe_iterator.h.

## Member Function Documentation

## _M_attach()

template<typename _Iterator , typename _Sequence >

void __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_attach | ( | _Safe_sequence_base * | __seq | ) |

inline

Attach iterator to the given sequence.

Definition at line 416 of file safe_iterator.h.

References __gnu_debug::_Safe_iterator_base::_M_attach().

## _M_attach_single()

template<typename _Iterator , typename _Sequence >

void __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_attach_single | ( | _Safe_sequence_base * | __seq | ) |

inline

Likewise, but not thread-safe.

Definition at line 421 of file safe_iterator.h.

References __gnu_debug::_Safe_iterator_base::_M_attach_single().

## _M_before_dereferenceable()

template<typename _Iterator , typename _Sequence >

bool __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_before_dereferenceable | ( |  | ) | const

inline

Is the iterator before a dereferenceable one?

Definition at line 431 of file safe_iterator.h.

References __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_incrementable(), and __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::base().

## _M_dereferenceable()

template<typename _Iterator , typename _Sequence >

bool __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_dereferenceable | ( |  | ) | const

inline

Is the iterator dereferenceable?

Definition at line 426 of file safe_iterator.h.

References __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_is_before_begin(), and __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_is_end().

Referenced by __gnu_debug::__check_dereferenceable().

## _M_incrementable()

template<typename _Iterator , typename _Sequence >

bool __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_incrementable | ( |  | ) | const

inline

Is the iterator incrementable?

Definition at line 443 of file safe_iterator.h.

References __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_is_end().

Referenced by __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_before_dereferenceable().

## _M_is_before_begin()

template<typename _Iterator , typename _Sequence >

bool __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_is_before_begin | ( |  | ) | const

inline

Is this iterator equal to the sequence's before_begin() iterator if any?

Definition at line 482 of file safe_iterator.h.

Referenced by __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_dereferenceable().

## _M_is_begin()

template<typename _Iterator , typename _Sequence >

bool __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_is_begin | ( |  | ) | const

inline

Is this iterator equal to the sequence's begin() iterator?

Definition at line 471 of file safe_iterator.h.

References __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::base().

## _M_is_beginnest()

template<typename _Iterator , typename _Sequence >

bool __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_is_beginnest | ( |  | ) | const

inline

Is this iterator equal to the sequence's before_begin() iterator if any or begin() otherwise?

Definition at line 488 of file safe_iterator.h.

## _M_is_end()

template<typename _Iterator , typename _Sequence >

bool __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_is_end | ( |  | ) | const

inline

Is this iterator equal to the sequence's end() iterator?

Definition at line 476 of file safe_iterator.h.

References __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::base().

Referenced by __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_dereferenceable(), and __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_incrementable().

## base()

template<typename _Iterator , typename _Sequence >

_Iterator& __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::base | ( |  | ) |

inline noexcept

Return the underlying iterator.

Definition at line 403 of file safe_iterator.h.

Referenced by __gnu_debug::__get_distance(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_before_dereferenceable(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_is_begin(), and __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_is_end().

## operator _Iterator()

template<typename _Iterator , typename _Sequence >

__gnu_debug::_Safe_iterator< _Iterator, _Sequence >::operator _Iterator | ( |  | ) | const

inline noexcept

Conversion to underlying non-debug iterator to allow better interaction with non-debug containers.

Definition at line 412 of file safe_iterator.h.

## operator*()

template<typename _Iterator , typename _Sequence >

reference __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::operator* | ( |  | ) | const

inline noexcept

Iterator dereference.

Precondition
  iterator is dereferenceable

Definition at line 266 of file safe_iterator.h.

## operator++() [1/2]

template<typename _Iterator , typename _Sequence >

_Safe_iterator& __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::operator++ | ( |  | ) |

inline noexcept

Iterator preincrement.

Precondition
  iterator is incrementable

Definition at line 293 of file safe_iterator.h.

## operator++() [2/2]

template<typename _Iterator , typename _Sequence >

_Safe_iterator __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::operator++ | ( | int |  | ) |

inline noexcept

Iterator postincrement.

Precondition
  iterator is incrementable

Definition at line 308 of file safe_iterator.h.

## operator--() [1/2]

template<typename _Iterator , typename _Sequence >

_Safe_iterator& __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::operator-- | ( |  | ) |

inline noexcept

Iterator predecrement.

Precondition
  iterator is decrementable

Definition at line 323 of file safe_iterator.h.

## operator--() [2/2]

template<typename _Iterator , typename _Sequence >

_Safe_iterator __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::operator-- | ( | int |  | ) |

inline noexcept

Iterator postdecrement.

Precondition
  iterator is decrementable

Definition at line 338 of file safe_iterator.h.

## operator->()

template<typename _Iterator , typename _Sequence >

pointer __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::operator-> | ( |  | ) | const

inline noexcept

Iterator dereference.

Precondition
  iterator is dereferenceable

Definition at line 279 of file safe_iterator.h.

## operator=() [1/2]

template<typename _Iterator , typename _Sequence >

_Safe_iterator& __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::operator= | ( | _Safe_iterator< _Iterator, _Sequence > && | __x | ) |

inline noexcept

Move assignment.

Postcondition
  __x is singular and unattached

Definition at line 231 of file safe_iterator.h.

## operator=() [2/2]

template<typename _Iterator , typename _Sequence >

_Safe_iterator& __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::operator= | ( | const _Safe_iterator< _Iterator, _Sequence > & | __x | ) |

inline noexcept

Copy assignment.

Definition at line 199 of file safe_iterator.h.

The documentation for this class was generated from the following files:

- formatter.h
- safe_iterator.h
- safe_iterator.tcc